<form [formGroup]="form" (ngSubmit)="onSubmit()">
  <input type="text" formControlName="username" placeholder="username" />
  <br />
  <input type="text" formControlName="password" placeholder="password" />
  <br />
  <button type="submit">Submit</button>
  <br />
  <span *ngIf="!form?.get('username')?.valid && form?.get('username')?.touched"
    >Please enter a valid username</span
  >
  <br />
  <span *ngIf="!form?.get('password')?.valid && form?.get('password')?.touched"
    >Please enter a valid password</span
  >
  <br />
  <span>{{ longString | shorten }}</span>
  <br />
  <span>{{ longString | shorten: 10 }}</span>
  <br />
  <input type="text" placeholder="filter" formControlName="filter" />
  <span></span>
  <ul>
    <li
      *ngFor="let item of sampleItems | filter: form.get('filter')?.value || ''"
    >
      {{ item }}
    </li>
  </ul>
</form>
